Wireshark 2.9.0-477-g68ec514b The Wireshark network protocol analyzer

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | List of all members
QCPItemBracket Class Reference

A bracket for referencing/highlighting certain parts in the plot. More...

Inheritance diagram for QCPItemBracket:

## Public Types
enum | BracketStyle { bsSquare, bsRound, bsCurly, bsCalligraphic }

## Public Member Functions
| QCPItemBracket (QCustomPlot *parentPlot)
QPen | pen () const
QPen | selectedPen () const
double | length () const
BracketStyle | style () const
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setLength (double length)
void | setStyle (BracketStyle style)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Member Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Member Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Public Attributes
QCPItemPosition *const | left
QCPItemPosition *const | right
QCPItemAnchor *const | center

## Protected Types
enum | AnchorIndex { aiCenter }

## Protected Member Functions
virtual void | draw (QCPPainter *painter)
virtual QPointF | anchorPixelPoint (int anchorId) const
QPen | mainPen () const
Protected Member Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
double | rectSelectTest (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Member Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Protected Attributes
QPen | mPen
QPen | mSelectedPen
double | mLength
BracketStyle | mStyle
Protected Attributes inherited from QCPAbstractItem
bool | mClipToAxisRect
QPointer< QCPAxisRect > | mClipAxisRect
QList< QCPItemPosition * > | mPositions
QList< QCPItemAnchor * > | mAnchors
bool | mSelectable
bool | mSelected
Protected Attributes inherited from QCPLayerable
bool | mVisible
QCustomPlot * | mParentPlot
QPointer< QCPLayerable > | mParentLayerable
QCPLayer * | mLayer
bool | mAntialiased

## Additional Inherited Members
Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

A bracket for referencing/highlighting certain parts in the plot.

Bracket example. Blue dotted circles are anchors, solid blue discs are positions.

It has two positions, left and right, which define the span of the bracket. If left is actually farther to the left than right, the bracket is opened to the bottom, as shown in the example image.

The bracket supports multiple styles via setStyle. The length, i.e. how far the bracket stretches away from the embraced span, can be controlled with setLength.

Demonstrating the effect of different values for setLength, for styles bsCalligraphic and bsSquare. Anchors and positions are displayed for reference.

It provides an anchor center, to allow connection of other items, e.g. an arrow (QCPItemLine or QCPItemCurve) or a text label (QCPItemText), to the bracket.

## Member Enumeration Documentation

enum QCPItemBracket::BracketStyle

Enumerator
bsSquare | A brace with angled edges.
bsRound | A brace with round edges.
bsCurly | A curly brace.
bsCalligraphic | A curly brace with varying stroke width giving a calligraphic impression.

## Constructor & Destructor Documentation

QCPItemBracket::QCPItemBracket | ( | QCustomPlot * | parentPlot | ) |

Creates a bracket item and sets default values.

The constructed item can be added to the plot with QCustomPlot::addItem.

## Member Function Documentation

double QCPItemBracket::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the item is represented not by single lines but by an area like QCPItemRect or QCPItemText, a click inside the area returns a constant value greater zero (typically the selectionTolerance of the parent QCustomPlot multiplied by 0.99). If the click lies outside the area, this function returns -1.0.

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractItem.

void QCPItemBracket::setLength | ( | double | length | ) |

Sets the length in pixels how far the bracket extends in the direction towards the embraced span of the bracket (i.e. perpendicular to the left-right-direction)

Demonstrating the effect of different values for setLength, for styles bsCalligraphic and bsSquare. Anchors and positions are displayed for reference.

void QCPItemBracket::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the bracket.

Note that when the style is bsCalligraphic, only the color will be taken from the pen, the stroke and width are ignored. To change the apparent stroke width of a calligraphic bracket, use setLength, which has a similar effect.

See also
  setSelectedPen

void QCPItemBracket::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the bracket when selected

See also
  setPen, setSelected

void QCPItemBracket::setStyle | ( | QCPItemBracket::BracketStyle | style | ) |

Sets the style of the bracket, i.e. the shape/visual appearance.

See also
  setPen

The documentation for this class was generated from the following files:

- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.h
- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.cpp